package cn.citycraft.Residence.commandmain;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import cn.citycraft.PluginHelper.commands.BaseCommand;
import cn.citycraft.PluginHelper.commands.DefaultCommand;
import cn.citycraft.PluginHelper.commands.HandlerSubCommand;
import cn.citycraft.Residence.ResidenceMain;
import cn.citycraft.Residence.commandsub.CommandArea;
import cn.citycraft.Residence.commandsub.CommandBank;
import cn.citycraft.Residence.commandsub.CommandCheck;
import cn.citycraft.Residence.commandsub.CommandCheckSelf;
import cn.citycraft.Residence.commandsub.CommandClearFlags;
import cn.citycraft.Residence.commandsub.CommandCompass;
import cn.citycraft.Residence.commandsub.CommandConfirm;
import cn.citycraft.Residence.commandsub.CommandCreate;
import cn.citycraft.Residence.commandsub.CommandCurrent;
import cn.citycraft.Residence.commandsub.CommandDefault;
import cn.citycraft.Residence.commandsub.CommandGive;
import cn.citycraft.Residence.commandsub.CommandGset;
import cn.citycraft.Residence.commandsub.CommandInfo;
import cn.citycraft.Residence.commandsub.CommandKick;
import cn.citycraft.Residence.commandsub.CommandLease;
import cn.citycraft.Residence.commandsub.CommandLimits;
import cn.citycraft.Residence.commandsub.CommandList;
import cn.citycraft.Residence.commandsub.CommandListAll;
import cn.citycraft.Residence.commandsub.CommandListAllHidden;
import cn.citycraft.Residence.commandsub.CommandListHidden;
import cn.citycraft.Residence.commandsub.CommandLists;
import cn.citycraft.Residence.commandsub.CommandLset;
import cn.citycraft.Residence.commandsub.CommandMarket;
import cn.citycraft.Residence.commandsub.CommandMaterial;
import cn.citycraft.Residence.commandsub.CommandMessage;
import cn.citycraft.Residence.commandsub.CommandMirror;
import cn.citycraft.Residence.commandsub.CommandPset;
import cn.citycraft.Residence.commandsub.CommandRemove;
import cn.citycraft.Residence.commandsub.CommandRemoveAll;
import cn.citycraft.Residence.commandsub.CommandRename;
import cn.citycraft.Residence.commandsub.CommandRenameArea;
import cn.citycraft.Residence.commandsub.CommandSelect;
import cn.citycraft.Residence.commandsub.CommandServer;
import cn.citycraft.Residence.commandsub.CommandSet;
import cn.citycraft.Residence.commandsub.CommandSetOwner;
import cn.citycraft.Residence.commandsub.CommandSubList;
import cn.citycraft.Residence.commandsub.CommandSubZone;
import cn.citycraft.Residence.commandsub.CommandTool;
import cn.citycraft.Residence.commandsub.CommandTp;
import cn.citycraft.Residence.commandsub.CommandTpSet;
import cn.citycraft.Residence.commandsub.CommandUnStuck;
import cn.citycraft.Residence.commandsub.CommandVersion;

public class CommandRes extends BaseCommand implements DefaultCommand {
	HandlerSubCommand hdsubcmd;

	ResidenceMain plugin;

	public CommandRes(final ResidenceMain plugin) {
		super("res", "residence", "resadmin");
		this.plugin = plugin;
		hdsubcmd = new HandlerSubCommand(plugin);

		hdsubcmd.registerCommand(new CommandArea(plugin));
		hdsubcmd.registerCommand(new CommandBank(plugin));
		hdsubcmd.registerCommand(new CommandCheck(plugin));
		hdsubcmd.registerCommand(new CommandCheckSelf(plugin));
		hdsubcmd.registerCommand(new CommandClearFlags(plugin));
		hdsubcmd.registerCommand(new CommandCompass(plugin));
		hdsubcmd.registerCommand(new CommandConfirm(plugin));
		hdsubcmd.registerCommand(new CommandCreate(plugin));
		hdsubcmd.registerCommand(new CommandCurrent(plugin));
		hdsubcmd.registerCommand(new CommandDefault(plugin));
		hdsubcmd.registerCommand(new CommandGive(plugin));
		hdsubcmd.registerCommand(new CommandGset(plugin));
		hdsubcmd.registerCommand(new CommandInfo(plugin));
		hdsubcmd.registerCommand(new CommandKick(plugin));
		hdsubcmd.registerCommand(new CommandLease(plugin));
		hdsubcmd.registerCommand(new CommandLimits(plugin));
		hdsubcmd.registerCommand(new CommandList(plugin));
		hdsubcmd.registerCommand(new CommandListAll(plugin));
		hdsubcmd.registerCommand(new CommandListAllHidden(plugin));
		hdsubcmd.registerCommand(new CommandListHidden(plugin));
		hdsubcmd.registerCommand(new CommandLists(plugin));
		hdsubcmd.registerCommand(new CommandLset(plugin));
		hdsubcmd.registerCommand(new CommandMarket(plugin));
		hdsubcmd.registerCommand(new CommandMaterial(plugin));
		hdsubcmd.registerCommand(new CommandMessage(plugin));
		hdsubcmd.registerCommand(new CommandMirror(plugin));
		hdsubcmd.registerCommand(new CommandPset(plugin));
		hdsubcmd.registerCommand(new CommandRemove(plugin));
		hdsubcmd.registerCommand(new CommandRemoveAll(plugin));
		hdsubcmd.registerCommand(new CommandRename(plugin));
		hdsubcmd.registerCommand(new CommandRenameArea(plugin));
		hdsubcmd.registerCommand(new CommandSelect(plugin));
		hdsubcmd.registerCommand(new CommandServer(plugin));
		hdsubcmd.registerCommand(new CommandSet(plugin));
		hdsubcmd.registerCommand(new CommandSetOwner(plugin));
		hdsubcmd.registerCommand(new CommandSubList(plugin));
		hdsubcmd.registerCommand(new CommandSubZone(plugin));
		hdsubcmd.registerCommand(new CommandTool(plugin));
		hdsubcmd.registerCommand(new CommandTp(plugin));
		hdsubcmd.registerCommand(new CommandTpSet(plugin));
		hdsubcmd.registerCommand(new CommandUnStuck(plugin));
		hdsubcmd.registerCommand(new CommandVersion(plugin));

		hdsubcmd.setDefaultCommand(this);

		plugin.getCommand("residence").setTabCompleter(hdsubcmd);
	}

	@Override
	public void defaultExecute(final CommandSender sender, final Command command, final String label) throws CommandException {
		commandHelp(new String[] { "?" }, true, sender);
	}

	@Override
	public void execute(final CommandSender sender, final Command command, final String label, final String[] args) throws CommandException {
		boolean resadmin = false;
		if (sender instanceof Player) {
			if (label.equalsIgnoreCase("resadmin")) {
				if (plugin.getPermissionManager().isResidenceAdmin((Player) sender)) {
					resadmin = true;
				} else {
					sender.sendMessage(ChatColor.RED + plugin.getLanguage().getPhrase("NonAdmin"));
				}
			}
		} else {
			resadmin = true;
		}
		if (args.length > 0 && args[args.length - 1].equalsIgnoreCase("?") || args.length > 1 && args[args.length - 2].equals("?")) {
			commandHelp(args, resadmin, sender);
			return;
		}
		if (plugin.getConfigManager().allowAdminsOnly()) {
			if (!resadmin) {
				sender.sendMessage(ChatColor.RED + plugin.getLanguage().getPhrase("AdminOnly"));
				return;
			}
		}
		hdsubcmd.onCommand(sender, resadmin ? command : null, label, args);
	}

	private void commandHelp(final String[] args, final boolean resadmin, final CommandSender sender) {
		if (plugin.getHelppages() != null) {
			String helppath = "res";
			for (final String arg : args) {
				if (arg.equalsIgnoreCase("?")) {
					break;
				}
				helppath = helppath + "." + arg;
			}
			int page = 1;
			if (!args[args.length - 1].equalsIgnoreCase("?")) {
				try {
					page = Integer.parseInt(args[args.length - 1]);
				} catch (final Exception ex) {
					sender.sendMessage(ChatColor.RED + plugin.getLanguage().getPhrase("InvalidHelp"));
				}
			}
			if (plugin.getHelppages().containesEntry(helppath)) {
				plugin.getHelppages().printHelp(sender, page, helppath);
			}
		}
	}
}
