package cn.citycraft.Residence.commandsub;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import cn.citycraft.PluginHelper.commands.BaseCommand;
import cn.citycraft.Residence.ResidenceMain;
import cn.citycraft.Residence.protection.ClaimedResidence;
import cn.citycraft.Residence.protection.ResidenceManager;
import cn.citycraft.Residence.text.Language;

public class CommandClearFlags extends BaseCommand {
	ResidenceMain plugin;

	public CommandClearFlags(final ResidenceMain plugin) {
		super("clearflags");
		this.plugin = plugin;
		setMinimumArguments(1);
		setOnlyPlayerExecutable();
		setPossibleArguments("<领地名称>");
	}

	@Override
	public void execute(final CommandSender sender, final Command command, final String label, final String[] args) throws CommandException {
		final Player player = (Player) sender;
		final boolean resadmin = (command != null);
		final ResidenceManager rmanager = plugin.getResidenceManager();
		final Language language = plugin.getLanguage();

		if (!resadmin) {
			player.sendMessage(ChatColor.RED + language.getPhrase("NoPermission"));
			return;
		}
		final ClaimedResidence area = rmanager.getByName(args[1]);
		if (area != null) {
			area.getPermissions().clearFlags();
			player.sendMessage(ChatColor.GREEN + language.getPhrase("FlagsCleared"));
		} else {
			player.sendMessage(ChatColor.RED + language.getPhrase("InvalidResidence"));
		}
	}

}
