package cn.citycraft.Residence.commandsub;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import com.sk89q.worldedit.bukkit.WorldEditPlugin;

import cn.citycraft.PluginHelper.commands.BaseCommand;
import cn.citycraft.Residence.ResidenceMain;
import cn.citycraft.Residence.protection.ResidenceManager;
import cn.citycraft.Residence.selection.SelectionManager;
import cn.citycraft.Residence.text.Language;

public class CommandCreate extends BaseCommand {
	ResidenceMain plugin;

	public CommandCreate(final ResidenceMain plugin) {
		super("create", "new");
		this.plugin = plugin;
		setMinimumArguments(1);
		setOnlyPlayerExecutable();
		setPossibleArguments("<领地名称>");
	}

	@Override
	public void execute(final CommandSender sender, final Command command, final String label, final String[] args) throws CommandException {
		final Player player = (Player) sender;
		final boolean resadmin = (command != null);
		final ResidenceManager rmanager = plugin.getResidenceManager();
		final Language language = plugin.getLanguage();
		final SelectionManager smanager = plugin.getSelectionManager();
		final WorldEditPlugin wep = (WorldEditPlugin) plugin.getServer().getPluginManager().getPlugin("WorldEdit");
		if (wep != null) {
			if (wep.getConfig().getInt("wand-item") == plugin.getConfigManager().getSelectionTooldID()) {
				smanager.worldEdit(player);
			}
		}
		if (smanager.hasPlacedBoth(player.getName())) {
			rmanager.addResidence(player, args[0], smanager.getPlayerLoc1(player.getName()), smanager.getPlayerLoc2(player.getName()), resadmin);
		} else {
			player.sendMessage(ChatColor.RED + language.getPhrase("SelectPoints"));
		}
	}

}
