package cn.citycraft.Residence.commandsub;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import cn.citycraft.PluginHelper.commands.BaseCommand;
import cn.citycraft.Residence.ResidenceMain;
import cn.citycraft.Residence.protection.ClaimedResidence;
import cn.citycraft.Residence.protection.ResidenceManager;
import cn.citycraft.Residence.text.Language;

public class CommandServer extends BaseCommand {
	ResidenceMain plugin;

	public CommandServer(final ResidenceMain plugin) {
		super("server");
		this.plugin = plugin;
		setMinimumArguments(1);
		setOnlyPlayerExecutable();
	}

	@Override
	public void execute(final CommandSender sender, final Command command, final String label, final String[] args) throws CommandException {
		final Player player = (Player) sender;
		final boolean resadmin = (command != null);
		final ResidenceManager rmanager = plugin.getResidenceManager();
		final Language language = plugin.getLanguage();

		if (!resadmin) {
			player.sendMessage(ChatColor.RED + language.getPhrase("NoPermission"));
			return;
		}
		final ClaimedResidence res = rmanager.getByName(args[0]);
		if (res == null) {
			player.sendMessage(ChatColor.RED + language.getPhrase("InvalidResidence"));
			return;
		}
		res.getPermissions().setOwner("Server Land", false);
		player.sendMessage(ChatColor.GREEN + language.getPhrase("ResidenceOwnerChange", ChatColor.YELLOW + args[0] + ChatColor.GREEN + "." + ChatColor.YELLOW + "Server Land" + ChatColor.GREEN));

	}

}
