package cn.citycraft.Residence.listeners.flag;

import org.bukkit.ChatColor;
import org.bukkit.entity.Arrow;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;

import cn.citycraft.Residence.ResidenceMain;
import cn.citycraft.Residence.manager.EntityManager;
import cn.citycraft.Residence.protection.ClaimedResidence;
import cn.citycraft.Residence.protection.FlagPermissions;

public class ResidenceAnimalKillingListener implements Listener {
	EntityManager entitymanager;
	ResidenceMain plugin;

	public ResidenceAnimalKillingListener(final ResidenceMain plugin) {
		this.plugin = plugin;
		this.entitymanager = plugin.getEntityManager();
		FlagPermissions.addFlag("animalkilling");
	}

	@EventHandler(priority = EventPriority.LOWEST)
	public void onAnimalKilling(final EntityDamageByEntityEvent event) {
		final Entity damager = event.getDamager();
		if ((!(damager instanceof Arrow)) && (!(damager instanceof Player))) {
			return;
		}
		Player cause;
		if ((damager instanceof Arrow) && (!(((Arrow) damager).getShooter() instanceof Player))) {
			return;
		} else if (damager instanceof Player) {
			cause = (Player) damager;
		} else {
			cause = (Player) ((Arrow) damager).getShooter();
		}

		if (plugin.isResAdminOn(cause)) {
			return;
		}

		final Entity entity = event.getEntity();
		final ClaimedResidence res = plugin.getResidenceManager().getByLoc(entity.getLocation());

		if (res != null && !res.getPermissions().playerHas(cause.getName(), "animalkilling", true)) {
			if (entitymanager.isAnimal(entity)) {
				cause.sendMessage(ChatColor.RED + plugin.getLanguage().getPhrase("NoPermission"));
				event.setCancelled(true);
			}
		}
	}

}
