package cn.citycraft.Residence.listeners.flag;

import java.util.HashMap;

import org.bukkit.ChatColor;
import org.bukkit.GameMode;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityDamageEvent.DamageCause;

import com.bekvon.bukkit.residence.event.ResidenceChangedEvent;
import com.bekvon.bukkit.residence.event.ResidenceDeleteEvent;
import com.bekvon.bukkit.residence.event.ResidenceFlagChangeEvent;

import cn.citycraft.Residence.ResidenceMain;
import cn.citycraft.Residence.protection.ClaimedResidence;
import cn.citycraft.Residence.protection.FlagPermissions;
import cn.citycraft.Residence.protection.ResidencePermissions;

public class ResidenceFlyListener implements Listener {

	HashMap<Player, Player> fall = new HashMap<Player, Player>();
	ResidenceMain plugin;

	public ResidenceFlyListener(final ResidenceMain plugin) {
		this.plugin = plugin;
		FlagPermissions.addFlag("fly");
		FlagPermissions.addResidenceOnlyFlag("fly");
	}

	@EventHandler(ignoreCancelled = true)
	public void FlagChange(final ResidenceFlagChangeEvent e) {
		final ClaimedResidence res = e.getResidence();
		for (final Player p : res.getPlayersInResidence()) {
			if (!permCheck(p)) {
				if (!resPermCheck(res, p)) {
					ChangePlayerFly(p, false);
				} else {
					ChangePlayerFly(p, true);
				}
			}
		}
	}

	// ResidenceDeleteEvent.class
	// ResidenceFlagChangeEvent.class

	public void onFallDamage(final EntityDamageEvent e) {
		if (e.getEntity() instanceof Player) {
			final Player p = (Player) e.getEntity();
			if (e.getCause() == DamageCause.FALL) {
				if (p == fall.get(p)) {
					fall.remove(p);
					e.setCancelled(true);
				}
			}
		}
	}

	@EventHandler(ignoreCancelled = true)
	public void resChange(final ResidenceChangedEvent event) {
		final Player player = event.getPlayer();
		final ClaimedResidence resto = event.getTo();
		if (!permCheck(player)) {
			if (!resPermCheck(resto, player)) {
				ChangePlayerFly(player, false);
			} else {
				ChangePlayerFly(player, true);
			}
		}
	}

	@EventHandler(ignoreCancelled = true)
	public void ResDelete(final ResidenceDeleteEvent e) {
		final ClaimedResidence res = e.getResidence();
		for (final Player p : res.getPlayersInResidence()) {
			if (!permCheck(p)) {
				ChangePlayerFly(p, false);
			}
		}
	}

	void ChangePlayerFly(final Player p, final boolean fly) {
		if (p.getAllowFlight() && !fly) {
			if (p.isFlying()) {
				fall.put(p, p);
			}
			p.setAllowFlight(false);
			p.sendMessage(ChatColor.RED + plugin.getLanguage().getPhrase("FlagDeny", "fly"));
		}
		if (!p.getAllowFlight() && fly) {
			if (p == fall.get(p)) {
				fall.remove(p);
			}
			p.setAllowFlight(true);
		}
	}

	boolean permCheck(final Player p) {
		return p.hasPermission("resfly.ignore") || p.isOp() || p.getGameMode() == GameMode.CREATIVE;
	}

	boolean resPermCheck(final ClaimedResidence res, final Player p) {
		if (res == null) {
			return false;
		}
		final ResidencePermissions perms = res.getPermissions();
		return perms.playerHas(p.getName(), "fly", false);
	}
}