package cn.citycraft.Residence.listeners.flag;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;

import cn.citycraft.Residence.ResidenceMain;
import cn.citycraft.Residence.manager.EntityManager;
import cn.citycraft.Residence.protection.ClaimedResidence;
import cn.citycraft.Residence.protection.FlagPermissions;

public class ResidenceInteractListener implements Listener {
	EntityManager entitymanager;
	ResidenceMain plugin;

	public ResidenceInteractListener(final ResidenceMain plugin) {
		this.plugin = plugin;
		this.entitymanager = plugin.getEntityManager();
		FlagPermissions.addFlag("interact");
		FlagPermissions.addFlagToFlagGroup("trusted", "interact");
	}

	@EventHandler(priority = EventPriority.LOWEST)
	public void onInteract(final PlayerInteractEvent e) {
		final Player p = e.getPlayer();
		if (plugin.isResAdminOn(p)) {
			return;
		}
		final ItemStack it = p.getItemInHand();
		if (it == null || it.getType() == Material.AIR) {
			return;
		}
		final Location loc = e.getClickedBlock().getLocation();
		final ClaimedResidence res = plugin.getResidenceManager().getByLoc(loc);
		if (res == null) {
			return;
		}
		final FlagPermissions hasPerm = plugin.getPermsByLocForPlayer(loc, p);
		e.setCancelled(hasPerm.has("interact", true));
	}

}
