package cn.citycraft.Residence.manager;

import java.util.HashMap;
import java.util.Map.Entry;

import org.bukkit.event.Listener;
import org.bukkit.plugin.PluginManager;

import cn.citycraft.PluginHelper.config.FileConfig;
import cn.citycraft.Residence.ResidenceMain;
import cn.citycraft.Residence.listeners.flag.ResidenceAnimalKillingListener;
import cn.citycraft.Residence.listeners.flag.ResidenceFlyListener;
import cn.citycraft.Residence.listeners.flag.ResidenceInteractListener;

public class FlagManager {
	FileConfig config;
	HashMap<Boolean, Listener> flagmap;

	ResidenceMain plugin;

	public FlagManager(final ResidenceMain plugin) {
		this.plugin = plugin;
		this.config = new FileConfig(plugin, "flagconfig.yml");
	}

	public void init() {
		final PluginManager pm = plugin.getServer().getPluginManager();

		plugin.getLogger().info("初始化扩展Flag...");

		flagmap = new HashMap<Boolean, Listener>();

		flagmap.put(config.getBoolean("Flag.Fly", true), new ResidenceFlyListener(plugin));
		flagmap.put(config.getBoolean("Flag.AnimalKilling", true), new ResidenceAnimalKillingListener(plugin));
		flagmap.put(config.getBoolean("Flag.Interact", false), new ResidenceInteractListener(plugin));

		for (final Entry<Boolean, Listener> fm : flagmap.entrySet()) {
			if (fm.getKey()) {
				pm.registerEvents(fm.getValue(), plugin);
			}
		}
		plugin.getLogger().info("扩展Flag初始化完毕...");
	}
}
