package com.bekvon.bukkit.residence;

import java.io.File;
import java.util.Map;

import org.bukkit.Location;
import org.bukkit.entity.Player;

import cn.citycraft.Residence.ResidenceMain;
import cn.citycraft.Residence.chat.ChatManager;
import cn.citycraft.Residence.economy.EconomyInterface;
import cn.citycraft.Residence.economy.TransactionManager;
import cn.citycraft.Residence.economy.rent.RentManager;
import cn.citycraft.Residence.itemlist.WorldItemManager;
import cn.citycraft.Residence.manager.ConfigManager;
import cn.citycraft.Residence.manager.EntityManager;
import cn.citycraft.Residence.permissions.PermissionManager;
import cn.citycraft.Residence.protection.ClaimedResidence;
import cn.citycraft.Residence.protection.FlagPermissions;
import cn.citycraft.Residence.protection.LeaseManager;
import cn.citycraft.Residence.protection.PermissionListManager;
import cn.citycraft.Residence.protection.ResidenceManager;
import cn.citycraft.Residence.protection.WorldFlagManager;
import cn.citycraft.Residence.selection.SelectionManager;
import cn.citycraft.Residence.text.Language;
import cn.citycraft.Residence.text.help.HelpEntry;

public class Residence {
	static ResidenceMain instance;

	public Residence(final ResidenceMain instance) {
		Residence.instance = instance;
	}

	public static ChatManager getChatManager() {
		return instance.getChatManager();
	}

	public static ConfigManager getConfigManager() {
		return instance.getConfigManager();
	}

	public static File getDataLocation() {
		return instance.getDataFolder();
	}

	public static Map<String, String> getDeleteConfirm() {
		return instance.getDeleteConfirm();
	}

	public static EconomyInterface getEconomyManager() {
		return instance.getEconomyManager();
	}

	public static EntityManager getEntityManager() {
		return instance.getEntityManager();
	}

	public static HelpEntry getHelppages() {
		return instance.getHelppages();
	}

	public static WorldItemManager getItemManager() {
		return instance.getItemManager();
	}

	public static Language getLanguage() {
		if (instance.getLanguage() == null) {
			instance.setLanguage(new Language());
		}
		return instance.getLanguage();
	}

	public static LeaseManager getLeaseManager() {
		return instance.getLeaseManager();
	}

	public static PermissionListManager getPermissionListManager() {
		return instance.getPermissionListManager();
	}

	public static PermissionManager getPermissionManager() {
		return instance.getPermissionManager();
	}

	public static FlagPermissions getPermsByLoc(final Location loc) {
		final ClaimedResidence res = getResidenceManager().getByLoc(loc);
		if (res != null) {
			return res.getPermissions();
		} else {
			return getWorldFlags().getPerms(loc.getWorld().getName());
		}
	}

	public static FlagPermissions getPermsByLocForPlayer(final Location loc, final Player player) {
		final ClaimedResidence res = getResidenceManager().getByLoc(loc);
		if (res != null) {
			return res.getPermissions();
		} else if (player != null) {
			return getWorldFlags().getPerms(player);
		} else {
			return getWorldFlags().getPerms(loc.getWorld().getName());
		}
	}

	public static RentManager getRentManager() {
		return instance.getRentManager();
	}

	public static ResidenceManager getResidenceManager() {
		return instance.getResidenceManager();
	}

	public static SelectionManager getSelectionManager() {
		return instance.getSelectionManager();
	}

	public static TransactionManager getTransactionManager() {
		return instance.getTransactionManager();
	}

	public static WorldFlagManager getWorldFlags() {
		return instance.getWorldFlags();
	}

	public static boolean isResAdminOn(final Player player) {
		if (instance.getResadminToggle().contains(player.getName())) {
			return true;
		}
		return false;
	}

	public static boolean isResAdminOn(final String player) {
		if (instance.getResadminToggle().contains(player.toLowerCase())) {
			return true;
		}
		return false;
	}

	public static boolean isUseWorldEdit() {
		return instance.isUseWorldEdit();
	}
}
